﻿using System.Collections.Generic;

namespace HeuristicLab.Problems.ProgramSynthesis {
  public class TreeNode<T> {
    public T Value { get; set; }
    public IList<TreeNode<T>> Children { get; private set; }
    public int Count { get; private set; }

    public TreeNode() {
      Children = new List<TreeNode<T>>();
      Count = 1;
    }

    public TreeNode(T value) : this() {
      Value = value;
    }

    public void Add(T value) {
      Children.Add(new TreeNode<T>(value));
      Count++;
    }

    public void AddNode(TreeNode<T> node) {
      Children.Add(node);
      Count += node.Count;
    }

    public void ReplaceNode(int index, TreeNode<T> node) {
      Count -= Children[index].Count;
      Children[index] = node;
      Count += node.Count;
    }
  }
}
